package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseFaristAccount;
import com.ruoyi.web.base.service.IBaseFaristAccountService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 一级科目 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-04
 */
@RestController
@RequestMapping("/base-farist-account")
public class BaseFaristAccountController {
    @Autowired
    private IBaseFaristAccountService baseFaristAccountService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("一级科目管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseFaristAccount baseFaristAccount, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseFaristAccountService.count(new QueryWrapper<BaseFaristAccount>().eq("org_id",loginOrgId).eq("farist_num", baseFaristAccount.getFaristNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseFaristAccount.setOrgId(loginOrgId);
        baseFaristAccount.setCreateBy(getUsername());

        return success(baseFaristAccountService.save(baseFaristAccount));
    }

    @ApiOperation("一级科目管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseFaristAccount baseFaristAccount, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseFaristAccountService.count(new QueryWrapper<BaseFaristAccount>().ne("id",baseFaristAccount.getId()).eq("org_id",loginOrgId).eq("farist_num", baseFaristAccount.getFaristNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseFaristAccount.setUpdateBy(getUsername());
        return success(baseFaristAccountService.updateById(baseFaristAccount));
    }

    @ApiOperation("一级科目管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseFaristAccountService.removeById(s);
        }
        return success();
    }

    @ApiOperation("一级科目管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(baseFaristAccountService.list(new QueryWrapper<BaseFaristAccount>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("一级科目管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(baseFaristAccountService.page(new Page<BaseFaristAccount>(pageNum,pageSize),new QueryWrapper<BaseFaristAccount>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("一级科目管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseFaristAccountService.getById(id));
    }

}
